diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -771,33 +1074,21 @@ class SquadService extends Actor {
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Availability.lift(position) match {
               case Some(true) =>
-                log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the requirements for squad position #$position")
                 squad.Membership(position).Requirements = certs
-                UpdateSquadDetail(squad.GUID, squad,
+                UpdateSquadDetail(
+                  squad.GUID,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Requirements(certs))))
                 )
               case Some(false) | None => ;
             }
 
           case LocationFollowsSquadLead(state) =>
-            if(state) {
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has moves the rally to the leader's position")
-            }
-            else {
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has let the rally move freely")
-            }
-            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
-            squad.LocationFollowsSquadLead = state
+            val features = squadFeatures(lSquadOpt.getOrElse(StartSquad(tplayer)).GUID)
+            features.LocationFollowsSquadLead = state
 
           case AutoApproveInvitationRequests(state) =>
-            if(state) {
-              log.info(s"${tplayer.Name}-${tplayer.Faction} is allowing all requests to join the squad")
-            }
-            else {
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has started screening invitation requests")
-            }
-            val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
-            squad.AutoApproveInvitationRequests = state
+            val features = squadFeatures(lSquadOpt.getOrElse(StartSquad(tplayer)).GUID)
+            features.AutoApproveInvitationRequests = state
 
           case FindLfsSoldiersForRole(position) =>
             lSquadOpt match {
@@ -807,7 +1098,7 @@ class SquadService extends Actor {
                 features.SearchForRole match {
                   case Some(-1) =>
                     //a proximity invitation has not yet cleared; nothing will be gained by trying to invite for a specific role
-                    log.debug("FindLfsSoldiersForRole: waiting for proximity invitations to clear")
+                    debug("FindLfsSoldiersForRole: waiting for proximity invitations to clear")
                   case _ =>
                     //either no role has ever been recruited, or some other role has been recruited
                     //normal LFS recruitment for the given position
@@ -817,17 +1108,18 @@ class SquadService extends Actor {
                     val outstandingActiveInvites = features.SearchForRole match {
                       case Some(pos) =>
                         RemoveQueuedInvitesForSquadAndPosition(sguid, pos)
-                        invites.collect { case(charId, InviteForRole(_,_, squad_guid, role)) if squad_guid == sguid && role == pos => charId }
+                        invites.collect { case(charId, LookingForSquadRoleInvite(_,_, squad_guid, role)) if squad_guid == sguid && role == pos => charId }
                       case None =>
                         List.empty[Long]
                     }
                     features.SearchForRole = position
                     //this will update the role entry in the GUI to visually indicate being searched for; only one will be displayed at a time
-                    SquadEvents.publish(
-                      SquadServiceResponse(s"/${tplayer.CharId}/Squad", SquadResponse.Detail(
+                    Publish(
+                      tplayer.CharId,
+                      SquadResponse.Detail(
                         sguid,
                         SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().CharId(char_id = 0L).Name(name = ""))))
-                      ))
+                      )
                     )
                     //collect all players that are eligible for invitation to the new position
                     //divide into players with an active invite (A) and players with a queued invite (B)
@@ -849,8 +1141,8 @@ class SquadService extends Actor {
                       case (outstandingPlayerList, invitedPlayerList) =>
                         //players who were actively invited for the previous position and are eligible for the new position
                         outstandingPlayerList.foreach { charId =>
-                          val bid = invites(charId).asInstanceOf[InviteForRole]
-                          invites(charId) = InviteForRole(bid.char_id, bid.name, sguid, position)
+                          val bid = invites(charId).asInstanceOf[LookingForSquadRoleInvite]
+                          invites(charId) = LookingForSquadRoleInvite(bid.char_id, bid.name, sguid, position)
                         }
                         //players who were actively invited for the previous position but are ineligible for the new position
                         (features.ProxyInvites filterNot (outstandingPlayerList contains)) foreach RemoveInvite
@@ -864,7 +1156,7 @@ class SquadService extends Actor {
                         invitedPlayers.foreach { invitedPlayer =>
                           AddInviteAndRespond(
                             invitedPlayer,
-                            InviteForRole(invitingPlayer, name, sguid, position),
+                            LookingForSquadRoleInvite(invitingPlayer, name, sguid, position),
                             invitingPlayer,
                             name
                           )
@@ -884,7 +1176,7 @@ class SquadService extends Actor {
                 squadFeatures(sguid).SearchForRole = None
                 //remove active invites
                 invites.filter {
-                  case (_, InviteForRole(_, _, _guid, pos)) => _guid == sguid && position.contains(pos)
+                  case (_, LookingForSquadRoleInvite(_, _, _guid, pos)) => _guid == sguid && position.contains(pos)
                   case _ => false
                 }
                   .keys.foreach { charId =>
@@ -893,7 +1185,7 @@ class SquadService extends Actor {
                 //remove queued invites
                 queuedInvites.foreach { case (charId, queue) =>
                   val filtered = queue.filterNot {
-                    case InviteForRole(_, _, _guid, _) => _guid == sguid
+                    case LookingForSquadRoleInvite(_, _, _guid, _) => _guid == sguid
                     case _ => false
                   }
                   queuedInvites += charId -> filtered
@@ -908,20 +1200,20 @@ class SquadService extends Actor {
 
           case RequestListSquad() =>
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
-            if(!squad.Listed && squad.Task.nonEmpty && squad.ZoneId > 0) {
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has opened public recruitment for squad ${squad.Task}")
-              squad.Listed = true
+            val features = squadFeatures(squad.GUID)
+            if(!features.Listed && squad.Task.nonEmpty && squad.ZoneId > 0) {
+              features.Listed = true
               InitialAssociation(squad)
-              sender ! SquadServiceResponse("", SquadResponse.SetListSquad(squad.GUID))
+              Publish(sender, SquadResponse.SetListSquad(squad.GUID))
               UpdateSquadList(squad, None)
             }
 
           case StopListSquad() =>
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
-            if(squad.Listed) {
-              log.info(s"${tplayer.Name}-${tplayer.Faction} has closed public recruitment for squad ${squad.Task}")
-              squad.Listed = false
-              sender ! SquadServiceResponse("", SquadResponse.AssociateWithSquad(PlanetSideGUID(0)))
+            val features = squadFeatures(squad.GUID)
+            if(features.Listed) {
+              features.Listed = false
+              Publish(sender, SquadResponse.SetListSquad(PlanetSideGUID(0)))
               UpdateSquadList(squad, None)
             }
 
@@ -939,11 +1231,12 @@ class SquadService extends Actor {
                   position.Orders = ""
                   position.Requirements = Set()
                 })
-                squad.LocationFollowsSquadLead = false
-                squad.AutoApproveInvitationRequests = false
-                UpdateSquadListWhenListed(squad, SquadInfo().Task("").ZoneId(None).Capacity(squad.Capacity))
-                UpdateSquadDetail(guid, squad)
-                sender ! SquadServiceResponse("", SquadResponse.AssociateWithSquad(PlanetSideGUID(0)))
+                val features = squadFeatures(squad.GUID)
+                features.LocationFollowsSquadLead = false
+                features.AutoApproveInvitationRequests = false
+                UpdateSquadListWhenListed(features, SquadInfo().Task("").ZoneId(None).Capacity(squad.Capacity))
+                UpdateSquadDetail(squad)
+                Publish(sender, SquadResponse.AssociateWithSquad(PlanetSideGUID(0)))
                 squadFeatures(guid).InitialAssociation = true
                 //do not unlist an already listed squad
               case Some(squad) =>
@@ -956,49 +1249,35 @@ class SquadService extends Actor {
             (pSquadOpt, action) match {
               //the following action can be performed by the squad leader and maybe an unaffiliated player
               case (Some(squad), SelectRoleForYourself(position)) =>
-                log.info(s"${tplayer.Name} would like the #${position+1} spot in the same squad")
-                val membership = squad.Membership.zipWithIndex
-                val toMember = squad.Membership(position)
-                if(squad.Leader.CharId == tplayer.CharId) {
-                  //TODO squad leader currently disallowed
-                } else
-                //the squad leader may swap to any open position; a normal member has to validate against requirements
-                if((squad.Leader.CharId == tplayer.CharId && toMember.CharId == 0) || ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
-                  membership.find { case (member, _) => member.CharId == tplayer.CharId } match {
-                    case Some((fromMember, fromIndex)) =>
-                      SwapMemberPosition(squad, toMember, fromMember)
-                      if(fromIndex == squad.LeaderPositionIndex) {
-                        squad.LeaderPositionIndex = position
-                      }
-                      //RemoveInvite(tplayer.CharId).foreach { _ =>
-                      //close the old bids out
-                      //}
-                      membership
-                        .filter { case (_member, _) => _member.CharId > 0 }
-                        .foreach { case (_member, _) =>
-                          SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromIndex, position)))
-                        }
-                      UpdateSquadDetail(squad.GUID, squad)
-                    case _ => ;
-                    //somehow, this is not our squad; do nothing, for now
-                  }
-                }
-                else {
-                  //not qualified for requested position
-                }
+                //TODO should be possible, but doesn't work correctly due to UI squad cards not updating as expected
+//                if(squad.Leader.CharId == tplayer.CharId) {
+//                  //squad leader currently disallowed
+//                } else
+//                //the squad leader may swap to any open position; a normal member has to validate against requirements
+//                if(squad.Leader.CharId == tplayer.CharId || ValidOpenSquadPosition(squad, position, tplayer.Certifications)) {
+//                  squad.Membership.zipWithIndex.find { case (member, _) => member.CharId == tplayer.CharId } match {
+//                    case Some((fromMember, fromIndex)) =>
+//                      SwapMemberPosition(squad.Membership(position), fromMember)
+//                      Publish(squadFeatures(squad.GUID).ToChannel, SquadResponse.AssignMember(squad, fromIndex, position))
+//                      UpdateSquadDetail(squad)
+//                    case _ => ;
+//                    //somehow, this is not our squad; do nothing, for now
+//                  }
+//                }
+//                else {
+//                  //not qualified for requested position
+//                }
 
               //the following action can be performed by an unaffiliated player
               case (None, SelectRoleForYourself(position)) =>
                 //not a member of any squad, but we might become a member of this one
                 GetSquad(guid) match {
                   case Some(squad) =>
-                    val toMember = squad.Membership(position)
-                    if(ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
+                    if(ValidOpenSquadPosition(squad, position, tplayer.Certifications)) {
                       //we could join but we may need permission from the squad leader first
-                      log.info(s"${tplayer.Name} would like the #${position+1} spot in the squad ${squad.Task}.")
                       AddInviteAndRespond(
                         squad.Leader.CharId,
-                        BidForRole(tplayer, guid, position),
+                        RequestRole(tplayer, guid, position),
                         invitingPlayer = 0L, //we ourselves technically are ...
                         tplayer.Name
                       )
@@ -1014,42 +1293,42 @@ class SquadService extends Actor {
                   case Some(squad) =>
                     //assumption: a player who is cancelling will rarely end up with their invite queued
                     val leaderCharId = squad.Leader.CharId
-                    //clean up any active BidForRole invite entry where we are the player who wants to join the leader's squad
+                    //clean up any active RequestRole invite entry where we are the player who wants to join the leader's squad
                     ((invites.get(leaderCharId) match {
-                      case out @ Some(entry) if entry.isInstanceOf[BidForRole] &&
-                        entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer =>
+                      case out @ Some(entry) if entry.isInstanceOf[RequestRole] &&
+                        entry.asInstanceOf[RequestRole].player.CharId == cancellingPlayer =>
                         out
                       case _ =>
                         None
                     }) match {
-                      case Some(entry : BidForRole) =>
+                      case Some(entry : RequestRole) =>
                         RemoveInvite(leaderCharId)
-                        SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
+                        Publish(leaderCharId, SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None)))
                         NextInviteAndRespond(leaderCharId)
                         Some(true)
                       case _ =>
                         None
                     }).orElse(
-                      //look for a queued BidForRole entry where we are the player who wants to join the leader's squad
+                      //look for a queued RequestRole entry where we are the player who wants to join the leader's squad
                       (queuedInvites.get(leaderCharId) match {
                         case Some(_list) =>
                           (_list, _list.indexWhere { entry =>
-                            entry.isInstanceOf[BidForRole] &&
-                              entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer
+                            entry.isInstanceOf[RequestRole] &&
+                              entry.asInstanceOf[RequestRole].player.CharId == cancellingPlayer
                           })
                         case None =>
                           (Nil, -1)
                       }) match {
                         case (_, -1) =>
                           None //no change
-                        case (list, index) if list.size == 1 =>
-                          val entry = list.head.asInstanceOf[BidForRole]
-                          SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
+                        case (list, _) if list.size == 1 =>
+                          val entry = list.head.asInstanceOf[RequestRole]
+                          Publish(leaderCharId, SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None)))
                           queuedInvites.remove(leaderCharId)
                           Some(true)
                         case (list, index) =>
-                          val entry = list(index).asInstanceOf[BidForRole]
-                          SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
+                          val entry = list(index).asInstanceOf[RequestRole]
+                          Publish(leaderCharId, SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None)))
                           queuedInvites(leaderCharId) = list.take(index) ++ list.drop(index+1)
                           Some(true)
                       }
@@ -1065,16 +1344,10 @@ class SquadService extends Actor {
                   //TODO squad leader currently disallowed
                   case (Some((fromMember, fromPosition)), (toMember, _)) if fromPosition != 0 =>
                     val name = fromMember.Name
-                    SwapMemberPosition(squad, toMember, fromMember)
-                    if(fromPosition == squad.LeaderPositionIndex) {
-                      squad.LeaderPositionIndex = position
-                    }
-                    membership
-                      .filter({ case (_member, _) => _member.CharId > 0 })
-                      .foreach { case (_member, _) =>
-                        SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromPosition, position)))
-                      }
-                    UpdateSquadDetail(squad.GUID, squad,
+                    SwapMemberPosition(toMember, fromMember)
+                    Publish(squadFeatures(guid).ToChannel, SquadResponse.AssignMember(squad, fromPosition, position))
+                    UpdateSquadDetail(
+                      squad.GUID,
                       SquadDetail().Members(List(
                         SquadPositionEntry(position, SquadPositionDetail().CharId(fromMember.CharId).Name(fromMember.Name)),
                         SquadPositionEntry(fromPosition, SquadPositionDetail().CharId(char_id).Name(name))
@@ -1087,183 +1360,32 @@ class SquadService extends Actor {
               case (_, SearchForSquadsWithParticularRole(_/*role*/, _/*requirements*/, _/*zone_id*/, _/*search_mode*/)) =>
                 //though we should be able correctly search squads as is intended
                 //I don't know how search results should be prioritized or even how to return search results to the user
-                sender ! SquadServiceResponse("", SquadResponse.SquadSearchResults())
+                Publish(sender, SquadResponse.SquadSearchResults())
 
               //the following action can be performed by anyone
               case (_, DisplaySquad()) =>
+                val charId = tplayer.CharId
                 GetSquad(guid) match {
+                  case Some(squad) if memberToSquad.get(charId).isEmpty =>
+                    continueToMonitorDetails += charId -> squad.GUID
+                    Publish(sender, SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
                   case Some(squad) =>
-                    sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
-                  case None => ;
+                    Publish(sender, SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+                  case _ => ;
                 }
 
               //the following message is feedback from a specific client, awaiting proper initialization
               case (_, SquadMemberInitializationIssue()) =>
-              //            GetSquad(guid) match {
-              //              case Some(squad) =>
-              //                sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
-              //              case None => ;
-              //            }
+//            GetSquad(guid) match {
+//              case Some(squad) =>
+//                Publish(sender, SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+//              case None => ;
+//            }
 
               case msg => ;
                 log.warn(s"Unsupported squad definition behavior: $msg")
             }
         }
-        // etc..
-        (pSquadOpt, action) match {
-          //the following action can be performed by the squad leader and maybe an unaffiliated player
-          case (Some(squad), SelectRoleForYourself(position)) =>
-            log.info(s"${tplayer.Name} would like the #${position+1} spot in this squad")
-            val membership = squad.Membership.zipWithIndex
-            val toMember = squad.Membership(position)
-            if(squad.Leader.CharId == tplayer.CharId) {
-              //TODO squad leader currently disallowed
-            } else
-            //the squad leader may swap to any open position; a normal member has to validate against requirements
-            if((squad.Leader.CharId == tplayer.CharId && toMember.CharId == 0) || ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
-              membership.find { case (member, _) => member.CharId == tplayer.CharId } match {
-                case Some((fromMember, fromIndex)) =>
-                  SwapMemberPosition(squad, toMember, fromMember)
-                  if(fromIndex == squad.LeaderPositionIndex) {
-                    squad.LeaderPositionIndex = position
-                  }
-                  //RemoveInvite(tplayer.CharId).foreach { _ =>
-                    //close the old bids out
-                  //}
-                  membership
-                    .filter { case (_member, _) => _member.CharId > 0 }
-                    .foreach { case (_member, _) =>
-                      SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromIndex, position)))
-                    }
-                  UpdateSquadDetail(squad.GUID, squad)
-                case _ => ;
-                //somehow, this is not our squad; do nothing, for now
-              }
-            }
-            else {
-              //not qualified for requested position
-            }
-
-          //the following action can be performed by an unaffiliated player
-          case (None, SelectRoleForYourself(position)) =>
-            //not a member of any squad, but we might become a member of this one
-            GetSquad(guid) match {
-              case Some(squad) =>
-                val toMember = squad.Membership(position)
-                if(ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
-                  //we could join but we may need permission from the squad leader first
-                  log.info(s"Player ${tplayer.Name} would like to join the squad ${squad.Task}.")
-                  AddInviteAndRespond(
-                    squad.Leader.CharId,
-                    BidForRole(tplayer, guid, position),
-                    invitingPlayer = 0L, //we ourselves technically are ...
-                    tplayer.Name
-                  )
-                }
-              case None => ;
-              //squad does not exist? assume old local data; force update to correct discrepancy
-            }
-
-          //the following action can be performed by anyone who has tried to join a squad
-          case (_, CancelSelectRoleForYourself(_)) =>
-            val cancellingPlayer = tplayer.CharId
-            GetSquad(guid) match {
-              case Some(squad) =>
-                //assumption: a player who is cancelling will rarely end up with their invite queued
-                val leaderCharId = squad.Leader.CharId
-                //clean up any active BidForRole invite entry where we are the player who wants to join the leader's squad
-                ((invites.get(leaderCharId) match {
-                  case out @ Some(entry) if entry.isInstanceOf[BidForRole] &&
-                    entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer =>
-                    out
-                  case _ =>
-                    None
-                }) match {
-                  case Some(entry : BidForRole) =>
-                    RemoveInvite(leaderCharId)
-                    SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
-                    NextInviteAndRespond(leaderCharId)
-                    Some(true)
-                  case _ =>
-                    None
-                }).orElse(
-                  //look for a queued BidForRole entry where we are the player who wants to join the leader's squad
-                  (queuedInvites.get(leaderCharId) match {
-                    case Some(_list) =>
-                      (_list, _list.indexWhere { entry =>
-                        entry.isInstanceOf[BidForRole] &&
-                          entry.asInstanceOf[BidForRole].player.CharId == cancellingPlayer
-                      })
-                    case None =>
-                      (Nil, -1)
-                  }) match {
-                    case (_, -1) =>
-                      None //no change
-                    case (list, index) if list.size == 1 =>
-                      val entry = list.head.asInstanceOf[BidForRole]
-                      SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
-                      queuedInvites.remove(leaderCharId)
-                      Some(true)
-                    case (list, index) =>
-                      val entry = list(index).asInstanceOf[BidForRole]
-                      SquadEvents.publish( SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Cancel, 0, 0, cancellingPlayer, None, entry.player.Name, false, Some(None))))
-                      queuedInvites(leaderCharId) = list.take(index) ++ list.drop(index+1)
-                      Some(true)
-                  }
-                )
-
-              case _ => ;
-            }
-
-          //the following action can be performed by ???
-          case (Some(squad), AssignSquadMemberToRole(position, char_id)) =>
-            val membership = squad.Membership.zipWithIndex
-            (membership.find({ case (member, _) => member.CharId == char_id}), membership(position)) match {
-              //TODO squad leader currently disallowed
-              case (Some((fromMember, fromPosition)), (toMember, _)) if fromPosition != 0 =>
-                val name = fromMember.Name
-                SwapMemberPosition(squad, toMember, fromMember)
-                if(fromPosition == squad.LeaderPositionIndex) {
-                  squad.LeaderPositionIndex = position
-                }
-                membership
-                  .filter({ case (_member, _) => _member.CharId > 0 })
-                  .foreach { case (_member, _) =>
-                    SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromPosition, position)))
-                  }
-                UpdateSquadDetail(squad.GUID, squad,
-                  SquadDetail().Members(List(
-                    SquadPositionEntry(position, SquadPositionDetail().CharId(fromMember.CharId).Name(fromMember.Name)),
-                    SquadPositionEntry(fromPosition, SquadPositionDetail().CharId(char_id).Name(name))
-                  ))
-                )
-              case _ => ;
-            }
-
-          //the following action can be peprformed by anyone
-          case (_, SearchForSquadsWithParticularRole(_/*role*/, _/*requirements*/, _/*zone_id*/, _/*search_mode*/)) =>
-            //though we should be able correctly search squads as is intended
-            //I don't know how search results should be prioritized or even how to return search results to the user
-            sender ! SquadServiceResponse("", SquadResponse.SquadSearchResults())
-
-          //the following action can be performed by anyone
-          case (_, DisplaySquad()) =>
-            GetSquad(guid) match {
-              case Some(squad) =>
-                sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
-              case None => ;
-            }
-
-          //the following message is feedback from a specific client, awaiting proper initialization
-          case (_, SquadMemberInitializationIssue()) =>
-//            GetSquad(guid) match {
-//              case Some(squad) =>
-//                sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
-//              case None => ;
-//            }
-
-          case _ => ;
-        }
 
       case SquadAction.Update(char_id, health, max_health, armor, max_armor, pos, zone_number) =>
         memberToSquad.get(char_id) match {
@@ -1274,13 +1396,16 @@ class SquadService extends Actor {
                 member.Armor = StatConverter.Health(armor, max_armor, min=1, max=64)
                 member.Position = pos
                 member.ZoneId = zone_number
-                sender ! SquadServiceResponse("", SquadResponse.UpdateMembers(
-                  squad,
-                  squad.Membership
-                    .filterNot { _.CharId == 0 }
-                    .map { member => SquadAction.Update(member.CharId, member.Health, 0, member.Armor, 0, member.Position, member.ZoneId) }
-                    .toList
-                ))
+                Publish(
+                  sender,
+                  SquadResponse.UpdateMembers(
+                    squad,
+                    squad.Membership
+                      .filterNot { _.CharId == 0 }
+                      .map { member => SquadAction.Update(member.CharId, member.Health, 0, member.Armor, 0, member.Position, member.ZoneId) }
+                      .toList
+                  )
+                )
               case _ => ;
             }
 
